<?php
/**
 * Plugin Name: Youstak
 * Plugin URI: http://youstak.com
 * Description: This plugin allows you to add a custom marketplace to your website.  You must first visit www.youstak.com to build the marketplace.
 * Version: 3.0.1
 * Author: YouStak, Inc
 * License: GPL2
 */


add_action('admin_menu', 'youstak_menu');
add_action('admin_init', 'youstak_settings');

/*
add_action('init', 'youstak_rewrite');
*/
add_action('parse_request', 'youstak_parse_request');

/*
function youstak_rewrite() {
    $rewrite_url = get_option('youstak-page-rewrite', 'youstak');

    //add_rewrite_rule( '^' . $rewrite_url . '/?', 'index.php?pagename=youstak', 'top' );   
    add_rewrite_rule( '\b' . $rewrite_url . '\b', 'index.php?pagename=youstak', 'top' );    

    flush_rewrite_rules('true');
}
*/

function youstak_menu() {
    add_menu_page('YouStak Settings', 'Youstak Settings', 'administrator', 'youstak-settings', 'youstak_settings_page', 'http://www.youstak.com/favicon16.ico');
}

function youstak_settings() {
    register_setting('youstak-settings-group', 'youstak-stakname');
    register_setting('youstak-settings-group', 'youstak-load-googlemaps');
    register_setting('youstak-settings-group', 'youstak-load-angular');
    register_setting('youstak-settings-group', 'youstak-facebook-appid');
    register_setting('youstak-settings-group', 'youstak-marketpage'); 
    register_setting('youstak-settings-group', 'youstak-maxitems'); 
    register_setting('youstak-settings-group', 'youstak-mapheight'); 
    register_setting('youstak-settings-group', 'youstak-textsize'); 
    register_setting('youstak-settings-group', 'youstak-customcss-path'); 



}

function youstak_settings_page() {
?>
<div class="wrap" style="font-size:16px">
    <img height="100"   src="http://www.youstak.com/files/youstaklogolongblue2.png">
    <div style="padding-left:20px">
        <h2 style="color:#398BCF">Welcome to the YouStak plugin</h2><br>
        <i style="color:#398BCF">To Add a Marketplace to your WordPress site, you must first create your Marketplace at <a href="https://www.youstak.com" target="_blank">youstak.com</a>.<br><br>Once you have created your marketplace, this plugin creates short codes so you can easily embed your marketplace into your Wordpress site.</i>
        <br><br> 
        <h5 style="font-size:16px;font-weight:300">
            This PlugIn creates:
            <ul style="list-style-type:circle;list-style-position:inside;">
                <li >a set of short codes for your Marketplace page,</li>
                <li >an items short code for embedding items from your Marketplace on other pages, and</li>
                <li >a member short code for other pages to create a membership feel to your site.</li>
            </ul>
            The <b>marketplace short codes</b> are used to embed the marketplace functionality inside your web page. This can be as simple as adding the [youstak_full] shortcode to your page. To fully cutomise your layout you can embed the individual marketplace shortcodes seperately. <br><br>
            The <b>items short code</b> can be added to any page to show a set of items from your marketplace. This is great for your home or landing page, if it is not your marketplace page. It's a great way to highlight items in your marketplace and bring visitors to your marketplace page.<br><br>
            The <b>member short code</b> allows you to give a "membership" feel to your visitors. Hide or display links based on their membership status, and show the members name and image on your menu.<br><br>
        </h5>

        <form method="post" action="options.php">
            <?php settings_fields( 'youstak-settings-group' ); ?>
            <?php do_settings_sections( 'youstak-settings-group' ); ?>
            <h3 style="color:#398BCF">Marketplace Settings </h3>
            <table class="form-table">
                <col width="80">
                <col width="80">
                <tr valign="top">
                <th scope="row">Markeplace Short Name *<br><i style="font-size:14px">(the short name for your marketplace generated by YouStak)</i></th>
                <td><input type="text" size="40" name="youstak-stakname" placeholder = "e.g. napawineriesdemostak" value="<?php echo esc_attr( get_option('youstak-stakname') ); ?>" /></td>
                </tr>
                <tr valign="top">
                <th scope="row">Your Marketplace Page *<br><i style="font-size:14px">(this helps us to guide users to your marketplace from your menu or home page)</i></th>
                <td><?php echo get_site_url(); ?>/<input type="text" name="youstak-marketpage" value="<?php echo esc_attr( get_option('youstak-marketpage', 'youstak') ); ?>" /></td>
                </tr>
                <tr valign="top">
                <th scope="row">Font Size Adjustment<br><i style="font-size:14px">(optional - Adjust the font size - 100=no change)</i></th>
                <td><input type="text" name="youstak-textsize" placeholder = "e.g. 100" value="<?php echo esc_attr( get_option('youstak-textsize','100') ); ?>" /></td>
                </tr>

                <tr valign="top">
                <th scope="row">Your Facebook App Id <br><i style="font-size:14px">(optional - only needed if you want your members to be able login using facebook)</i></th>
                <td><input type="text" name="youstak-facebook-appid" value="<?php echo esc_attr( get_option('youstak-facebook-appid') ); ?>" /></td>
                </tr>

                <tr valign="top">
                <th scope="row">Load Google Maps <br><i style="font-size:14px">(required unless already loaded)</i></th>
                <td><input type="checkbox" name="youstak-load-googlemaps" <?php echo esc_attr( get_option('youstak-load-googlemaps') ) ? " checked='checked'":""; ?> /></td>
                </tr>
                
                <tr valign="top">
                <th scope="row">Load Angularjs <br><i style="font-size:14px">(required unless already loaded)</i></th>
                <td><input type="checkbox" name="youstak-load-angular" <?php echo esc_attr( get_option('youstak-load-angular') ) ? " checked='checked'":""; ?> /></td>
                </tr>

                <th scope="row">Maximum Results<br><i style="font-size:14px">(optional - How many search results are returned per page)</i></th>
                <td><input type="text" name="youstak-maxitems" placeholder = "e.g. 12 "value="<?php echo esc_attr( get_option('youstak-maxitems','20') ); ?>" /></td>
                </tr>
                <tr valign="top">
                <th scope="row">Map Height<br><i style="font-size:14px">(optional - The height percent of screen of the map - 100=full height)</i></th>
                <td><input type="text" name="youstak-mapheight" placeholder = "e.g. 100" value="<?php echo esc_attr( get_option('youstak-mapheight','100') ); ?>" /></td>
                </tr>
                <tr valign="top">
                <th scope="row">A Custom CSS File Url <br><i style="font-size:14px">(optional - the full url to a custom css file )</i></th>
                <td><input type="text" size="60" name="youstak-customcss-path" placeholder = "e.g. http://www.mysite.com/mymarketplace.css" value="<?php echo esc_attr( get_option('youstak-customcss-path') ); ?>" /></td>
                </tr>                        
            </table>

            <?php submit_button(); ?>
            <h3 style="color:#398BCF;font-weight:300">Short Codes Created </h3>
            <h3 style="font-weight:300">Embed the marketplace with the standard layout:<br><i style="font-size:14px">(If you use this you don't need any other short codes)</i></h3>
            
            <table style="width:100%">
                <tr valign="top"><th scope="row" style="text-align:left">[youstak-full] </th><td> The full marketplace</td></tr>  
            </table>                
            <h3 style="font-weight:300">Embed each marketplace element seperately:<br><i style="font-size:14px">(Assign marketplace elements to each position in YouStak Manager)</i></h3>
            <table style="width:100%">
                <tr valign="top"><th scope="row" style="text-align:left">[youstak-engine] </th><td> This is required just once anywhere on the page.</td></tr>                 
                <tr valign="top"><th scope="row" style="text-align:left">[youstak-menu] </th><td> Menu Position</td></tr> 
                <tr valign="top"><th scope="row" style="text-align:left">[youstak-body] </th><td> Main Body Position</td></tr> 
            </table>
            <h3 style="font-weight:300">Codes for other pages on your site :<br><i style="font-size:14px">(Use this to allow members to be recognised on other pages of your site, and to show items from your marketplace.)</i></h3>
            <table style="width:100%">         
                <tr valign="top"><th scope="row" style="text-align:left">[youstak-items count=6 cols=3] </th><td> This will show 6 items in 3 columns at this position on the page</td></tr> 
                <tr valign="top"><th scope="row" style="text-align:left">[youstak-member] </th><td> This is required just once anywhere on each page to give a membership feel<br>It's not needed if you have [youstak-items],[youstak-full] or [youstak-engine] on the page already.</td></tr>                        
            </table>            
        </form>
    </div>
</div>

<?php

}


function youstak_parse_request(&$wp) {

    if (empty($wp->query_vars['pagename']))
        return; // page isn't permalink

    $p = $wp->query_vars['pagename'];

    if ( $p!="youstak")
        return;

    // setup hooks and filters to generate virtual movie page
//  add_action('template_include', 'youstak_template_include');
//    add_action('template_redirect', 'youstak_template_redir');
    add_filter('the_posts', 'youstak_the_posts');

    remove_filter('the_content', 'wpautop');

}
/*
function youstak_template_include($originaltemplate) {
    return  get_option('youstak-marketpage') ; 
}


function youstak_template_redir() {
    include( locate_template( get_option('youstak-marketpage'), false, false ) ); 

    get_template_part('page');

    exit;
}
*/
function youstak_full_content() {
    
    $stakname = get_option('youstak-stakname', "napawineriesdemostak");
    $marketpage=get_option('youstak-marketpage');
    $google_maps = get_option('youstak-load-googlemaps', false);
    $angular = get_option('youstak-load-angular', false);
    $appid = get_option( 'youstak-facebook-appid', null);
    $maxitems = get_option('youstak-maxitems', 20);
    $mapheight = get_option('youstak-mapheight', 100);
    $textsize = get_option('youstak-textsize', 100);
    $customcss=get_option('youstak-customcss-path');

    if($stakname=="")
        $stakname="napawineriesdemostak";

    

    $youstak_body = "<div data-YouStakBundle=\"youstak\" ></div>";

    $youstak_body .= "
<script id=\"youstakembed\" type=\"text/javascript\" src=\"https://www.youstak.com/stak/youstakembed/youstak.js\" ";
    $youstak_body .= " data-YouStakName=\"$stakname\" ";

    if(!$google_maps) {
        $youstak_body .= " data-noloadgoogle=\"1\" ";
    }
    if($customcss!=""){
        $youstak_body .= " data-customcss=\"$customcss\"";
    }

    if(!$angular) {
        $youstak_body .= " data-noloadangular=\"1\" ";
    }


    if(!empty($appid)) {
        $youstak_body .= " data-appid=\"$appid\"";
    }

    if(!empty($maxitems)) {
        $youstak_body .= " data-maxitems=\"$maxitems\"";
    }

    if(!empty($mapheight)) {
        $youstak_body .= " data-mapheight=\"$mapheight\"";
    }
    if(!empty($textsize)) {
        $youstak_body .= " data-textsize=\"$textsize\"";
    }

    $youstak_body .= "  ></script> ";

    return $youstak_body;
}

function youstak_view($viewname) {
    
    $stakname = get_option('youstak-stakname', "napawineriesdemostak");
    $marketpage=get_option('youstak-marketpage');
    $google_maps = get_option('youstak-load-googlemaps', false);
    $angular = get_option('youstak-load-angular', false);
    $appid = get_option( 'youstak-facebook-appid', null);
    $maxitems = get_option('youstak-maxitems', 20);
    $mapheight = get_option('youstak-mapheight', 100);
    $textsize = get_option('youstak-textsize', 100);
    $customcss=get_option('youstak-customcss-path');


    if($stakname=="")
        $stakname="napawineriesdemostak";

    if($viewname=='menu'){
        $youstak_body = "<div data-YouStakPosition=\"M\" ></div>";
    }else if ($viewname=='body'){
        $youstak_body = "<div data-YouStakPosition=\"F\" ></div>";      
    }else if ($viewname=='engine'){
        $youstak_body = "
    <script id=\"youstakembed\" type=\"text/javascript\" src=\"https://www.youstak.com/stak/youstakembed/youstak.js\" ";
        $youstak_body .= " data-YouStakName=\"$stakname\" ";

        if(!$google_maps) {
            $youstak_body .= " data-noloadgoogle=\"1\" ";
        }
        if($customcss!=""){
            $youstak_body .= " data-customcss=\"$customcss\"";
        }

        if(!$angular) {
            $youstak_body .= " data-noloadangular=\"1\" ";
        }
        if(!empty($appid)) {
            $youstak_body .= " data-appid=\"$appid\"";
        }
        if(!empty($maxitems)) {
            $youstak_body .= " data-maxitems=\"$maxitems\"";
        }

        if(!empty($mapheight)) {
            $youstak_body .= " data-mapheight=\"$mapheight\"";
        }

        if(!empty($textsize)) {
            $youstak_body .= " data-textsize=\"$textsize\"";
        }

        $youstak_body .= " ></script> ";
    }
    return $youstak_body;
}



function youstak_the_posts($posts) {
    // have to create a dummy post as otherwise many templates
    // don't call the_content filter
    global $wp, $wp_query;

    //create a fake post intance
    $p = new stdClass;
    // fill $p with everything a page in the database would have
    $p->ID = -1;
    $p->post_author = 1;
    $p->post_date = current_time('mysql');
    $p->post_date_gmt =  current_time('mysql', $gmt = 1);
    $p->post_content = youstak_full_content();
    $p->post_title = $pagetitle;
    $p->post_excerpt = '';
    $p->post_status = 'publish';
    $p->ping_status = 'closed';
    $p->post_password = '';
    $p->post_name = 'youstak'; // slug
    $p->to_ping = '';
    $p->pinged = '';
    $p->modified = $p->post_date;
    $p->modified_gmt = $p->post_date_gmt;
    $p->post_content_filtered = '';
    $p->post_parent = 0;
    $p->guid = get_home_url('/' . $p->post_name); // use url instead?
    $p->menu_order = 0;
    $p->post_type = 'page';
    $p->post_mime_type = '';
    $p->comment_status = 'closed';
    $p->comment_count = 0;
    $p->filter = 'raw';
    $p->ancestors = array(); // 3.6

    // reset wp_query properties to simulate a found page
    $wp_query->is_page = TRUE;
    $wp_query->is_singular = TRUE;
    $wp_query->is_home = FALSE;
    $wp_query->is_archive = FALSE;
    $wp_query->is_category = FALSE;
    unset($wp_query->query['error']);
    $wp->query = array();
    $wp_query->query_vars['error'] = '';
    $wp_query->is_404 = FALSE;

    $wp_query->current_post = $p->ID;
    $wp_query->found_posts = 1;
    $wp_query->post_count = 1;
    $wp_query->comment_count = 0;
    // -1 for current_comment displays comment if not logged in!
    $wp_query->current_comment = null;
    $wp_query->is_singular = 1;

    $wp_query->post = $p;
    $wp_query->posts = array($p);
    $wp_query->queried_object = $p;
    $wp_query->queried_object_id = $p->ID;
    $wp_query->current_post = $p->ID;
    $wp_query->post_count = 1;

    return array($p);
}

function youstak_shorttag_full() {
    return youstak_full_content();
}
function youstak_shorttag_menu() {
    return youstak_view('menu');
}
function youstak_shorttag_body() {
    return youstak_view('body');
}
function youstak_shorttag_engine() {
    return youstak_view('engine');
}
function youstak_shorttag_member() {
    $stakname = get_option('youstak-stakname', "napawineriesdemostak");
    $marketpage=get_option('youstak-marketpage');

    if($stakname=="")
        $stakname="napawineriesdemostak";

    $youstak_body = "<script id=\"youstakembed\" type=\"text/javascript\" src=\"https://www.youstak.com/stak/youstakembed/prod/youstakaction.js\"  data-YouStakName=\"$stakname\" data-marketpage=\"$marketpage\" ></script> ";

    return $youstak_body;
}

function youstak_shorttag_items($atts) {
    $count_default_value = "4";  // number of items to get
    $cols_default_value = "4";   // number of columns to display
    $type_default_value = "";   // type for item to get (more complex that just a number)

    extract( shortcode_atts( array(
        'count' => $count_default_value,
        'cols' => $cols_default_value,
        'type' => $type_default_value,
    ), $atts ) ); 

    $stakname = get_option('youstak-stakname', "napawineriesdemostak");
    $marketpage=get_option('youstak-marketpage');

    if($stakname=="")
        $stakname="napawineriesdemostak";

    $youstak_body = "<link rel=\"stylesheet\" type=\"text/css\" href=\"https://www.youstak.com/stak/youstakembed/prod/ys.css\"/>";

    $youstak_body .= "<div class=\"ys-".$cols."cols\" id=ysRepeatItem></div>";

    $youstak_body .= "<script id=\"youstakembed\" type=\"text/javascript\" src=\"https://www.youstak.com/stak/youstakembed/prod/youstakaction.js\"  data-YouStakName=\"$stakname\" data-marketpage=\"$marketpage\" ";

    if ($type == "")
        $youstak_body .= " data-action=\"R".$count."\" ";
    else
        $youstak_body .= " data-action=\"".$type."|".$count."\" ";

    $youstak_body .= " ></script> ";

    return $youstak_body;

}


add_shortcode('youstak-full', 'youstak_shorttag_full');
add_shortcode('youstak-menu', 'youstak_shorttag_menu');
add_shortcode('youstak-body', 'youstak_shorttag_body');
add_shortcode('youstak-engine', 'youstak_shorttag_engine');
add_shortcode('youstak-member', 'youstak_shorttag_member');
add_shortcode('youstak-items', 'youstak_shorttag_items');

